﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;

namespace XamPropertyGridBug
{
    public class MainViewModel : INotifyPropertyChanged
    {
        private ExampleData _data;

        public IList<string> AvailableValues => new List<string>
        {
            "Value01", "Value02", "Value03", "Value04", "Value05", "Value06", "Value07", "Value08", "Value09", "Value10",
            "Value11", "Value12", "Value13", "Value14", "Value15", "Value16", "Value17", "Value18", "Value19", "Value20",
            "Value21", "Value22", "Value23", "Value24", "Value25", "Value26", "Value27", "Value28", "Value29", "Value30",
            "Value31", "Value32", "Value33", "Value34", "Value35", "Value36", "Value37", "Value38", "Value39", "Value40",
        };

        public ExampleData Data { get => _data; set => SetField(ref _data, value); }

        public MainViewModel()
        {
            Data = new ExampleData();
        }

        #region INotifyPropertyChanged Implementation

        public event PropertyChangedEventHandler PropertyChanged;

        protected virtual void OnPropertyChanged([CallerMemberName] string propertyName = null)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }

        protected bool SetField<T>(ref T field, T value, [CallerMemberName] string propertyName = null)
        {
            if (EqualityComparer<T>.Default.Equals(field, value)) return false;
            field = value;
            OnPropertyChanged(propertyName);
            return true;
        }

        #endregion

    }
}
